
use crate::common::{Lazy, Symbol};
use crate::linker::Linker;
use crate::error::Error;
use xmas_elf::ElfFile;

mod object;
mod section;
mod section_iter;

use section_iter::SectionIter;
pub use object::ElfObject;

impl Linker<'_> {
    // shortcut to avoid turbofish
    pub fn elf() -> Self {
        Self::new(Vec::new())
    }
}

impl<'data> Lazy<&'data str, ElfFile<'data>> for Symbol<'data> {
    fn value(&self, src: &ElfFile<'data>) -> Result<&'data str, Error> {
        src.get_string(self.index)
            .map_err(|e| Error::StringError(e))
    }

    fn resolved(&self) -> bool {
        self.str_ref.is_some()
    }
}
